diff --git a/base/java-tools/src/com/netscape/cmstools/profile/ProfileEnableCLI.java b/base/java-tools/src/com/netscape/cmstools/profile/ProfileEnableCLI.java
new file mode 100644
index 0000000000000000000000000000000000000000..727e49b0ac429f38f3b5336e17214bdcb3027e9a
--- /dev/null
+++ b/base/java-tools/src/com/netscape/cmstools/profile/ProfileEnableCLI.java
@@ -0,0 +1,33 @@
+package com.netscape.cmstools.profile;
+
+import com.netscape.cmstools.cli.CLI;
+import com.netscape.cmstools.cli.MainCLI;
+
+public class ProfileEnableCLI extends CLI {
+
+    public ProfileCLI parent;
+
+    public ProfileEnableCLI(ProfileCLI parent) {
+        super("enable", "Enable profiles");
+        this.parent = parent;
+    }
+
+    public void printHelp() {
+        formatter.printHelp(parent.name + "-" + name + " <profile_id>", options);
+    }
+
+    public void execute(String[] args) throws Exception {
+
+        if (args.length != 1) {
+            printHelp();
+            System.exit(1);
+        }
+
+        String profileId = args[0];
+
+        parent.client.enableProfile(profileId);
+
+        MainCLI.printMessage("Enabled profile \"" + profileId + "\"");
+    }
+
+}
diff --git a/base/java-tools/src/com/netscape/cmstools/profile/ProfileFindCLI.java b/base/java-tools/src/com/netscape/cmstools/profile/ProfileFindCLI.java
new file mode 100644
index 0000000000000000000000000000000000000000..9ced7c0b8174be186b0942b7a2b43183d65609b5
--- /dev/null
+++ b/base/java-tools/src/com/netscape/cmstools/profile/ProfileFindCLI.java
@@ -0,0 +1,39 @@
+package com.netscape.cmstools.profile;
+
+import java.util.Collection;
+
+import com.netscape.certsrv.profile.ProfileDataInfo;
+import com.netscape.cmstools.cli.CLI;
+import com.netscape.cmstools.cli.MainCLI;
+
+public class ProfileFindCLI extends CLI {
+
+    public ProfileCLI parent;
+
+    public ProfileFindCLI(ProfileCLI parent) {
+        super("find", "Find profiles");
+        this.parent = parent;
+    }
+
+    public void printHelp() {
+        formatter.printHelp(parent.name + "-" + name + " [FILTER] [OPTIONS...]", options);
+    }
+
+    public void execute(String[] args) throws Exception {
+
+        Collection<ProfileDataInfo> infos = parent.client.listProfiles().getProfileInfos();
+        boolean first = true;
+
+        for (ProfileDataInfo info: infos) {
+            if (first) {
+                first = false;
+            } else {
+                System.out.println();
+            }
+            ProfileCLI.printProfileDataInfo(info);
+        }
+
+        MainCLI.printMessage("Number of entries returned " + infos.size());
+    }
+
+}
diff --git a/base/java-tools/src/com/netscape/cmstools/profile/ProfileModifyCLI.java b/base/java-tools/src/com/netscape/cmstools/profile/ProfileModifyCLI.java
new file mode 100644
index 0000000000000000000000000000000000000000..5259a7fe7a92e2e5212a9855b7faf3e13b6824a2
--- /dev/null
+++ b/base/java-tools/src/com/netscape/cmstools/profile/ProfileModifyCLI.java
@@ -0,0 +1,61 @@
+package com.netscape.cmstools.profile;
+
+import java.io.FileNotFoundException;
+
+import javax.xml.bind.JAXBException;
+
+import org.apache.commons.cli.CommandLine;
+import org.apache.commons.cli.ParseException;
+
+import com.netscape.certsrv.profile.ProfileData;
+import com.netscape.cmstools.cli.CLI;
+import com.netscape.cmstools.cli.MainCLI;
+
+public class ProfileModifyCLI extends CLI {
+
+    public ProfileCLI parent;
+
+    public ProfileModifyCLI(ProfileCLI parent) {
+        super("mod", "Modify profiles");
+        this.parent = parent;
+    }
+
+    public void printHelp() {
+        formatter.printHelp(parent.name + "-" + name + " <file>", options);
+    }
+
+    public void execute(String[] args) {
+        CommandLine cmd = null;
+
+        try {
+            cmd = parser.parse(options, args);
+        } catch (ParseException e) {
+            System.err.println("Error: " + e.getMessage());
+            printHelp();
+            System.exit(-1);
+        }
+
+        String[] cLineArgs = cmd.getArgs();
+
+        if (cLineArgs.length < 1) {
+            System.err.println("Error: No filename specified.");
+            printHelp();
+            System.exit(-1);
+        }
+        String filename = cLineArgs[0];
+        if (filename == null || filename.trim().length() == 0) {
+            System.err.println("Error: Missing input file name.");
+            printHelp();
+            System.exit(-1);
+        }
+
+        try {
+            ProfileData data = ProfileCLI.readProfileFromFile(filename);
+            parent.client.modifyProfile(data);
+            MainCLI.printMessage("Modified profile " + data.getId());
+        } catch (FileNotFoundException | JAXBException  e) {
+            System.err.println("Error: " + e.getMessage());
+            System.exit(-1);
+        }
+    }
+}
diff --git a/base/java-tools/src/com/netscape/cmstools/profile/ProfileRemoveCLI.java b/base/java-tools/src/com/netscape/cmstools/profile/ProfileRemoveCLI.java
new file mode 100644
index 0000000000000000000000000000000000000000..c2e3eae53f4879869fd474af99fbd2221a60ac59
--- /dev/null
+++ b/base/java-tools/src/com/netscape/cmstools/profile/ProfileRemoveCLI.java
@@ -0,0 +1,33 @@
+package com.netscape.cmstools.profile;
+
+import com.netscape.cmstools.cli.CLI;
+import com.netscape.cmstools.cli.MainCLI;
+
+public class ProfileRemoveCLI extends CLI {
+
+    public ProfileCLI parent;
+
+    public ProfileRemoveCLI(ProfileCLI parent) {
+        super("del", "Remove profiles");
+        this.parent = parent;
+    }
+
+    public void printHelp() {
+        formatter.printHelp(parent.name + "-" + name + " <profile_id>", options);
+    }
+
+    public void execute(String[] args) throws Exception {
+
+        if (args.length != 1) {
+            printHelp();
+            System.exit(1);
+        }
+
+        String profileId = args[0];
+
+        parent.client.deleteProfile(profileId);
+
+        MainCLI.printMessage("Deleted profile \"" + profileId + "\"");
+    }
+
+}
diff --git a/base/java-tools/src/com/netscape/cmstools/profile/ProfileShowCLI.java b/base/java-tools/src/com/netscape/cmstools/profile/ProfileShowCLI.java
new file mode 100644
index 0000000000000000000000000000000000000000..de83c1eb95474abd891cf6a5c8ccf5c99d460226
--- /dev/null
+++ b/base/java-tools/src/com/netscape/cmstools/profile/ProfileShowCLI.java
@@ -0,0 +1,71 @@
+package com.netscape.cmstools.profile;
+
+import org.apache.commons.cli.CommandLine;
+import org.apache.commons.cli.Option;
+import org.apache.commons.cli.ParseException;
+
+import com.netscape.certsrv.profile.ProfileData;
+import com.netscape.cmstools.cli.CLI;
+import com.netscape.cmstools.cli.MainCLI;
+
+public class ProfileShowCLI extends CLI {
+
+    public ProfileCLI parent;
+
+    public ProfileShowCLI(ProfileCLI parent) {
+        super("show", "Show profiles");
+        this.parent = parent;
+    }
+
+    public void printHelp() {
+        formatter.printHelp(parent.name + "-" + name + " <profile_id>", options);
+    }
+
+    public void execute(String[] args) throws Exception {
+        CommandLine cmd = null;
+
+        Option option = new Option(null, "output", true, "Output filename");
+        option.setArgName("filename");
+        options.addOption(option);
+
+        try {
+            cmd = parser.parse(options, args);
+        } catch (ParseException e) {
+            System.err.println("Error: " + e.getMessage());
+            printHelp();
+            System.exit(-1);
+        }
+
+        String[] cLineArgs = cmd.getArgs();
+        if (cLineArgs.length < 1) {
+            System.err.println("Error: Missing profile ID.");
+            printHelp();
+            System.exit(-1);
+        }
+
+        String profileId = cLineArgs[0];
+
+        String filename = null;
+        if (cmd.hasOption("output")) {
+            filename = cmd.getOptionValue("output");
+        } else {
+            System.err.println("Error: Missing output file name.");
+            printHelp();
+            System.exit(-1);
+        }
+
+        if (filename == null || filename.trim().length() == 0) {
+            System.err.println("Error: Missing output file name.");
+            printHelp();
+            System.exit(-1);
+        }
+
+        ProfileData profileData = parent.client.retrieveProfile(profileId);
+
+        MainCLI.printMessage("Profile \"" + profileId + "\"");
+
+        ProfileCLI.printProfile(profileData);
+        ProfileCLI.saveProfileToFile(filename, profileData);
+    }
+
+}
-- 
1.8.1.4

